com.hazelcast.jet.core.processor

## Class SourceProcessors

- java.lang.Object
- - com.hazelcast.jet.core.processor.SourceProcessors

-     public final class SourceProcessors
      extends Object

  Static utility class with factories of source processors (the DAG entry points). For other kinds for a vertices refer to the `package-level documentation`.

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <S,T> ProcessorMetaSupplier` | `convenientSourceP(DistributedFunction<? super Processor.Context,? extends S> createFn, DistributedBiConsumer<? super S,? super SourceBuilder.SourceBuffer<T>> fillBufferFn, DistributedConsumer<? super S> destroyFn, int preferredLocalParallelism)` Returns a supplier of processors for a source that the user can create using the `SourceBuilder`.
    `static <S,T> ProcessorMetaSupplier` | `convenientTimestampedSourceP(DistributedFunction<? super Processor.Context,? extends S> createFn, DistributedBiConsumer<? super S,? super SourceBuilder.TimestampedSourceBuffer<T>> fillBufferFn, WatermarkGenerationParams<? super com.hazelcast.jet.impl.JetEvent<T>> wmParams, DistributedConsumer<? super S> destroyFn, int preferredLocalParallelism)` Returns a supplier of processors for a source that the user can create using the `SourceBuilder`.
    `static ProcessorMetaSupplier` | `readCacheP(String cacheName)` Returns a supplier of processors for `Sources.cache(String)`.
    `static <R> ProcessorMetaSupplier` | `readFilesP(String directory, Charset charset, String glob, boolean sharedFileSystem, DistributedBiFunction<? super String,? super String,? extends R> mapOutputFn)` Returns a supplier of processors for `Sources.filesBuilder(java.lang.String)`.
    `static <T> ProcessorMetaSupplier` | `readJdbcP(DistributedSupplier<? extends Connection> connectionSupplier, ToResultSetFunction resultSetFn, DistributedFunction<? super ResultSet,? extends T> mapOutputFn)` Returns a supplier of processors for `Sources.jdbc( DistributedSupplier, ToResultSetFunction, DistributedFunction)`.
    `static <T> ProcessorMetaSupplier` | `readJdbcP(String connectionURL, String query, DistributedFunction<? super ResultSet,? extends T> mapOutputFn)` Returns a supplier of processors for `Sources.jdbc(String, String, DistributedFunction)`.
    `static ProcessorMetaSupplier` | `readListP(String listName)` Returns a supplier of processors for `Sources.list(String)`.
    `static ProcessorMetaSupplier` | `readMapP(String mapName)` Returns a supplier of processors for `Sources.map(String)`.
    `static <T,K,V> ProcessorMetaSupplier` | `readMapP(String mapName, Predicate<? super K,? super V> predicate, DistributedFunction<? super Map.Entry<K,V>,? extends T> projectionFn)` Returns a supplier of processors for `Sources.map(String, Predicate, DistributedFunction)`.
    `static <T,K,V> ProcessorMetaSupplier` | `readMapP(String mapName, Predicate<? super K,? super V> predicate, Projection<? super Map.Entry<K,V>,? extends T> projectionFn)` Returns a supplier of processors for `Sources.map(String, Predicate, Projection)`.
    `static ProcessorMetaSupplier` | `readRemoteCacheP(String cacheName, ClientConfig clientConfig)` Returns a supplier of processors for `Sources.remoteCache(String, ClientConfig)`.
    `static ProcessorMetaSupplier` | `readRemoteListP(String listName, ClientConfig clientConfig)` Returns a supplier of processors for `Sources.remoteList(String, ClientConfig)`.
    `static ProcessorMetaSupplier` | `readRemoteMapP(String mapName, ClientConfig clientConfig)` Returns a supplier of processors for `Sources.remoteMap(String, ClientConfig)`.
    `static <T,K,V> ProcessorMetaSupplier` | `readRemoteMapP(String mapName, ClientConfig clientConfig, Predicate<? super K,? super V> predicate, DistributedFunction<? super Map.Entry<K,V>,? extends T> projectionFn)` Returns a supplier of processors for `Sources.remoteMap(String, ClientConfig, Predicate, DistributedFunction)`.
    `static <T,K,V> ProcessorMetaSupplier` | `readRemoteMapP(String mapName, ClientConfig clientConfig, Predicate<? super K,? super V> predicate, Projection<? super Map.Entry<K,V>,? extends T> projection)` Returns a supplier of processors for `Sources.remoteMap(String, ClientConfig, Predicate, Projection)`.
    `static <T,K,V> ProcessorMetaSupplier` | `streamCacheP(String cacheName, DistributedPredicate<? super EventJournalCacheEvent<K,V>> predicateFn, DistributedFunction<? super EventJournalCacheEvent<K,V>,? extends T> projectionFn, JournalInitialPosition initialPos, WatermarkGenerationParams<? super T> wmGenParams)` Returns a supplier of processors for `Sources.cacheJournal(String, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.
    `static <K,V> ProcessorMetaSupplier` | `streamCacheP(String cacheName, JournalInitialPosition initialPos, WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)` Returns a supplier of processors for `Sources.cacheJournal(String, JournalInitialPosition)`.
    `static ProcessorMetaSupplier` | `streamFilesP(String watchedDirectory, Charset charset, String glob, boolean sharedFileSystem, DistributedBiFunction<? super String,? super String,?> mapOutputFn)` Returns a supplier of processors for `Sources.filesBuilder(java.lang.String)`.
    `static <T> ProcessorMetaSupplier` | `streamJmsQueueP(DistributedSupplier<? extends javax.jms.Connection> connectionSupplier, DistributedFunction<? super javax.jms.Connection,? extends javax.jms.Session> sessionFn, DistributedFunction<? super javax.jms.Session,? extends javax.jms.MessageConsumer> consumerFn, DistributedConsumer<? super javax.jms.Session> flushFn, DistributedFunction<? super javax.jms.Message,? extends T> projectionFn)` Returns a supplier of processors for `Sources.jmsQueueBuilder(com.hazelcast.jet.function.DistributedSupplier<? extends javax.jms.ConnectionFactory>)`.
    `static <T> ProcessorMetaSupplier` | `streamJmsTopicP(DistributedSupplier<? extends javax.jms.Connection> connectionSupplier, DistributedFunction<? super javax.jms.Connection,? extends javax.jms.Session> sessionFn, DistributedFunction<? super javax.jms.Session,? extends javax.jms.MessageConsumer> consumerFn, DistributedConsumer<? super javax.jms.Session> flushFn, DistributedFunction<? super javax.jms.Message,? extends T> projectionFn)` Returns a supplier of processors for `Sources.jmsTopicBuilder(com.hazelcast.jet.function.DistributedSupplier<? extends javax.jms.ConnectionFactory>)`.
    `static <T,K,V> ProcessorMetaSupplier` | `streamMapP(String mapName, DistributedPredicate<? super EventJournalMapEvent<K,V>> predicateFn, DistributedFunction<? super EventJournalMapEvent<K,V>,? extends T> projectionFn, JournalInitialPosition initialPos, WatermarkGenerationParams<? super T> wmGenParams)` Returns a supplier of processors for `Sources.mapJournal(String, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.
    `static <K,V> ProcessorMetaSupplier` | `streamMapP(String mapName, JournalInitialPosition initialPos, WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)` Returns a supplier of processors for `Sources.mapJournal(String, JournalInitialPosition)` )}.
    `static <T,K,V> ProcessorMetaSupplier` | `streamRemoteCacheP(String cacheName, ClientConfig clientConfig, DistributedPredicate<? super EventJournalCacheEvent<K,V>> predicateFn, DistributedFunction<? super EventJournalCacheEvent<K,V>,? extends T> projectionFn, JournalInitialPosition initialPos, WatermarkGenerationParams<? super T> wmGenParams)` Returns a supplier of processors for `Sources.remoteCacheJournal(String, ClientConfig, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.
    `static <K,V> ProcessorMetaSupplier` | `streamRemoteCacheP(String cacheName, ClientConfig clientConfig, JournalInitialPosition initialPos, WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)` Returns a supplier of processors for `Sources.remoteCacheJournal(String, ClientConfig, JournalInitialPosition)`.
    `static <T,K,V> ProcessorMetaSupplier` | `streamRemoteMapP(String mapName, ClientConfig clientConfig, DistributedPredicate<? super EventJournalMapEvent<K,V>> predicateFn, DistributedFunction<? super EventJournalMapEvent<K,V>,? extends T> projectionFn, JournalInitialPosition initialPos, WatermarkGenerationParams<? super T> wmGenParams)` Returns a supplier of processors for `Sources.remoteMapJournal(String, ClientConfig, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.
    `static <K,V> ProcessorMetaSupplier` | `streamRemoteMapP(String mapName, ClientConfig clientConfig, JournalInitialPosition initialPos, WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)` Returns a supplier of processors for `Sources.remoteMapJournal(String, ClientConfig, JournalInitialPosition)`.
    `static ProcessorMetaSupplier` | `streamSocketP(String host, int port, Charset charset)` Returns a supplier of processors for `Sources.socket(String, int, Charset)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### readMapP

          @Nonnull
          public static ProcessorMetaSupplier readMapP(@Nonnull
                                                                String mapName)

      Returns a supplier of processors for `Sources.map(String)`.

    - #### readMapP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier readMapP(@Nonnull
                                                                        String mapName,
                                                                        @Nonnull
                                                                        Predicate<? super K,? super V> predicate,
                                                                        @Nonnull
                                                                        Projection<? super Map.Entry<K,V>,? extends T> projectionFn)

      Returns a supplier of processors for `Sources.map(String, Predicate, Projection)`.

    - #### readMapP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier readMapP(@Nonnull
                                                                        String mapName,
                                                                        @Nonnull
                                                                        Predicate<? super K,? super V> predicate,
                                                                        @Nonnull
                                                                        DistributedFunction<? super Map.Entry<K,V>,? extends T> projectionFn)

      Returns a supplier of processors for `Sources.map(String, Predicate, DistributedFunction)`.

    - #### streamMapP

          @Nonnull
          public static <K,V> ProcessorMetaSupplier streamMapP(@Nonnull
                                                                        String mapName,
                                                                        @Nonnull
                                                                        JournalInitialPosition initialPos,
                                                                        @Nonnull
                                                                        WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)

      Returns a supplier of processors for `Sources.mapJournal(String, JournalInitialPosition)` )}.

    - #### streamMapP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier streamMapP(@Nonnull
                                                                          String mapName,
                                                                          @Nonnull
                                                                          DistributedPredicate<? super EventJournalMapEvent<K,V>> predicateFn,
                                                                          @Nonnull
                                                                          DistributedFunction<? super EventJournalMapEvent<K,V>,? extends T> projectionFn,
                                                                          @Nonnull
                                                                          JournalInitialPosition initialPos,
                                                                          @Nonnull
                                                                          WatermarkGenerationParams<? super T> wmGenParams)

      Returns a supplier of processors for `Sources.mapJournal(String, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.

    - #### readRemoteMapP

          @Nonnull
          public static ProcessorMetaSupplier readRemoteMapP(@Nonnull
                                                                      String mapName,
                                                                      @Nonnull
                                                                      ClientConfig clientConfig)

      Returns a supplier of processors for `Sources.remoteMap(String, ClientConfig)`.

    - #### readRemoteMapP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier readRemoteMapP(@Nonnull
                                                                              String mapName,
                                                                              @Nonnull
                                                                              ClientConfig clientConfig,
                                                                              @Nonnull
                                                                              Predicate<? super K,? super V> predicate,
                                                                              @Nonnull
                                                                              Projection<? super Map.Entry<K,V>,? extends T> projection)

      Returns a supplier of processors for `Sources.remoteMap(String, ClientConfig, Predicate, Projection)`.

    - #### readRemoteMapP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier readRemoteMapP(@Nonnull
                                                                              String mapName,
                                                                              @Nonnull
                                                                              ClientConfig clientConfig,
                                                                              @Nonnull
                                                                              Predicate<? super K,? super V> predicate,
                                                                              @Nonnull
                                                                              DistributedFunction<? super Map.Entry<K,V>,? extends T> projectionFn)

      Returns a supplier of processors for `Sources.remoteMap(String, ClientConfig, Predicate, DistributedFunction)`.

    - #### streamRemoteMapP

          @Nonnull
          public static <K,V> ProcessorMetaSupplier streamRemoteMapP(@Nonnull
                                                                              String mapName,
                                                                              @Nonnull
                                                                              ClientConfig clientConfig,
                                                                              @Nonnull
                                                                              JournalInitialPosition initialPos,
                                                                              @Nonnull
                                                                              WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)

      Returns a supplier of processors for `Sources.remoteMapJournal(String, ClientConfig, JournalInitialPosition)`.

    - #### streamRemoteMapP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier streamRemoteMapP(@Nonnull
                                                                                String mapName,
                                                                                @Nonnull
                                                                                ClientConfig clientConfig,
                                                                                @Nonnull
                                                                                DistributedPredicate<? super EventJournalMapEvent<K,V>> predicateFn,
                                                                                @Nonnull
                                                                                DistributedFunction<? super EventJournalMapEvent<K,V>,? extends T> projectionFn,
                                                                                @Nonnull
                                                                                JournalInitialPosition initialPos,
                                                                                @Nonnull
                                                                                WatermarkGenerationParams<? super T> wmGenParams)

      Returns a supplier of processors for `Sources.remoteMapJournal(String, ClientConfig, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.

    - #### readCacheP

          @Nonnull
          public static ProcessorMetaSupplier readCacheP(@Nonnull
                                                                  String cacheName)

      Returns a supplier of processors for `Sources.cache(String)`.

    - #### streamCacheP

          @Nonnull
          public static <K,V> ProcessorMetaSupplier streamCacheP(@Nonnull
                                                                          String cacheName,
                                                                          @Nonnull
                                                                          JournalInitialPosition initialPos,
                                                                          @Nonnull
                                                                          WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)

      Returns a supplier of processors for `Sources.cacheJournal(String, JournalInitialPosition)`.

    - #### streamCacheP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier streamCacheP(@Nonnull
                                                                            String cacheName,
                                                                            @Nonnull
                                                                            DistributedPredicate<? super EventJournalCacheEvent<K,V>> predicateFn,
                                                                            @Nonnull
                                                                            DistributedFunction<? super EventJournalCacheEvent<K,V>,? extends T> projectionFn,
                                                                            @Nonnull
                                                                            JournalInitialPosition initialPos,
                                                                            @Nonnull
                                                                            WatermarkGenerationParams<? super T> wmGenParams)

      Returns a supplier of processors for `Sources.cacheJournal(String, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.

    - #### readRemoteCacheP

          @Nonnull
          public static ProcessorMetaSupplier readRemoteCacheP(@Nonnull
                                                                        String cacheName,
                                                                        @Nonnull
                                                                        ClientConfig clientConfig)

      Returns a supplier of processors for `Sources.remoteCache(String, ClientConfig)`.

    - #### streamRemoteCacheP

          @Nonnull
          public static <K,V> ProcessorMetaSupplier streamRemoteCacheP(@Nonnull
                                                                                String cacheName,
                                                                                @Nonnull
                                                                                ClientConfig clientConfig,
                                                                                @Nonnull
                                                                                JournalInitialPosition initialPos,
                                                                                @Nonnull
                                                                                WatermarkGenerationParams<? super Map.Entry<K,V>> wmGenParams)

      Returns a supplier of processors for `Sources.remoteCacheJournal(String, ClientConfig, JournalInitialPosition)`.

    - #### streamRemoteCacheP

          @Nonnull
          public static <T,K,V> ProcessorMetaSupplier streamRemoteCacheP(@Nonnull
                                                                                  String cacheName,
                                                                                  @Nonnull
                                                                                  ClientConfig clientConfig,
                                                                                  @Nonnull
                                                                                  DistributedPredicate<? super EventJournalCacheEvent<K,V>> predicateFn,
                                                                                  @Nonnull
                                                                                  DistributedFunction<? super EventJournalCacheEvent<K,V>,? extends T> projectionFn,
                                                                                  @Nonnull
                                                                                  JournalInitialPosition initialPos,
                                                                                  @Nonnull
                                                                                  WatermarkGenerationParams<? super T> wmGenParams)

      Returns a supplier of processors for `Sources.remoteCacheJournal(String, ClientConfig, DistributedPredicate, DistributedFunction, JournalInitialPosition)`.

    - #### readListP

          @Nonnull
          public static ProcessorMetaSupplier readListP(@Nonnull
                                                                 String listName)

      Returns a supplier of processors for `Sources.list(String)`.

    - #### readRemoteListP

          @Nonnull
          public static ProcessorMetaSupplier readRemoteListP(@Nonnull
                                                                       String listName,
                                                                       @Nonnull
                                                                       ClientConfig clientConfig)

      Returns a supplier of processors for `Sources.remoteList(String, ClientConfig)`.

    - #### streamSocketP

          @Nonnull
          public static ProcessorMetaSupplier streamSocketP(@Nonnull
                                                                     String host,
                                                                     int port,
                                                                     @Nonnull
                                                                     Charset charset)

      Returns a supplier of processors for `Sources.socket(String, int, Charset)`.

    - #### readFilesP

          @Nonnull
          public static <R> ProcessorMetaSupplier readFilesP(@Nonnull
                                                                      String directory,
                                                                      @Nonnull
                                                                      Charset charset,
                                                                      @Nonnull
                                                                      String glob,
                                                                      boolean sharedFileSystem,
                                                                      @Nonnull
                                                                      DistributedBiFunction<? super String,? super String,? extends R> mapOutputFn)

      Returns a supplier of processors for `Sources.filesBuilder(java.lang.String)`. See `FileSourceBuilder.build()` for more details.

    - #### streamFilesP

          @Nonnull
          public static ProcessorMetaSupplier streamFilesP(@Nonnull
                                                                    String watchedDirectory,
                                                                    @Nonnull
                                                                    Charset charset,
                                                                    @Nonnull
                                                                    String glob,
                                                                    boolean sharedFileSystem,
                                                                    @Nonnull
                                                                    DistributedBiFunction<? super String,? super String,?> mapOutputFn)

      Returns a supplier of processors for `Sources.filesBuilder(java.lang.String)`. See `FileSourceBuilder.buildWatcher()` for more details.

    - #### streamJmsQueueP

          @Nonnull
          public static <T> ProcessorMetaSupplier streamJmsQueueP(@Nonnull
                                                                           DistributedSupplier<? extends javax.jms.Connection> connectionSupplier,
                                                                           @Nonnull
                                                                           DistributedFunction<? super javax.jms.Connection,? extends javax.jms.Session> sessionFn,
                                                                           @Nonnull
                                                                           DistributedFunction<? super javax.jms.Session,? extends javax.jms.MessageConsumer> consumerFn,
                                                                           @Nonnull
                                                                           DistributedConsumer<? super javax.jms.Session> flushFn,
                                                                           @Nonnull
                                                                           DistributedFunction<? super javax.jms.Message,? extends T> projectionFn)

      Returns a supplier of processors for `Sources.jmsQueueBuilder(com.hazelcast.jet.function.DistributedSupplier<? extends javax.jms.ConnectionFactory>)`.

    - #### streamJmsTopicP

          @Nonnull
          public static <T> ProcessorMetaSupplier streamJmsTopicP(@Nonnull
                                                                           DistributedSupplier<? extends javax.jms.Connection> connectionSupplier,
                                                                           @Nonnull
                                                                           DistributedFunction<? super javax.jms.Connection,? extends javax.jms.Session> sessionFn,
                                                                           @Nonnull
                                                                           DistributedFunction<? super javax.jms.Session,? extends javax.jms.MessageConsumer> consumerFn,
                                                                           @Nonnull
                                                                           DistributedConsumer<? super javax.jms.Session> flushFn,
                                                                           @Nonnull
                                                                           DistributedFunction<? super javax.jms.Message,? extends T> projectionFn)

      Returns a supplier of processors for `Sources.jmsTopicBuilder(com.hazelcast.jet.function.DistributedSupplier<? extends javax.jms.ConnectionFactory>)`.

    - #### readJdbcP

          public static <T> ProcessorMetaSupplier readJdbcP(@Nonnull
                                                            DistributedSupplier<? extends Connection> connectionSupplier,
                                                            @Nonnull
                                                            ToResultSetFunction resultSetFn,
                                                            @Nonnull
                                                            DistributedFunction<? super ResultSet,? extends T> mapOutputFn)

      Returns a supplier of processors for `Sources.jdbc( DistributedSupplier, ToResultSetFunction, DistributedFunction)`.

    - #### readJdbcP

          public static <T> ProcessorMetaSupplier readJdbcP(@Nonnull
                                                            String connectionURL,
                                                            @Nonnull
                                                            String query,
                                                            @Nonnull
                                                            DistributedFunction<? super ResultSet,? extends T> mapOutputFn)

      Returns a supplier of processors for `Sources.jdbc(String, String, DistributedFunction)`.

    - #### convenientSourceP

          @Nonnull
          public static <S,T> ProcessorMetaSupplier convenientSourceP(@Nonnull
                                                                               DistributedFunction<? super Processor.Context,? extends S> createFn,
                                                                               @Nonnull
                                                                               DistributedBiConsumer<? super S,? super SourceBuilder.SourceBuffer<T>> fillBufferFn,
                                                                               @Nonnull
                                                                               DistributedConsumer<? super S> destroyFn,
                                                                               int preferredLocalParallelism)

      Returns a supplier of processors for a source that the user can create using the `SourceBuilder`. This variant creates a source that emits items without timestamps.
      Type Parameters:
        `S` - type of the source's state object
        `T` - type of items the source emits
      Parameters:
        `createFn` - function that creates the source's state object
        `fillBufferFn` - function that fills Jet's buffer with items to emit
        `destroyFn` - function that cleans up the resources held by the state object
        `preferredLocalParallelism` - preferred local parallelism of the source vertex. Special values: -> use the cluster's default local parallelism; 0 -> create a single processor for the entire cluster (total parallelism = 1)

    - #### convenientTimestampedSourceP

          @Nonnull
          public static <S,T> ProcessorMetaSupplier convenientTimestampedSourceP(@Nonnull
                                                                                          DistributedFunction<? super Processor.Context,? extends S> createFn,
                                                                                          @Nonnull
                                                                                          DistributedBiConsumer<? super S,? super SourceBuilder.TimestampedSourceBuffer<T>> fillBufferFn,
                                                                                          @Nonnull
                                                                                          WatermarkGenerationParams<? super com.hazelcast.jet.impl.JetEvent<T>> wmParams,
                                                                                          @Nonnull
                                                                                          DistributedConsumer<? super S> destroyFn,
                                                                                          int preferredLocalParallelism)

      Returns a supplier of processors for a source that the user can create using the `SourceBuilder`. This variant creates a source that emits timestamped events.
      Type Parameters:
        `S` - type of the source's state object
        `T` - type of items the source emits
      Parameters:
        `createFn` - function that creates the source's state object
        `fillBufferFn` - function that fills Jet's buffer with items to emit
        `destroyFn` - function that cleans up the resources held by the state object
        `preferredLocalParallelism` - preferred local parallelism of the source vertex. Special values: -> use the cluster's default local parallelism; 0 -> create a single processor for the entire cluster (total parallelism = 1)

Copyright © 2018. All rights reserved.